/****************************************************************************
    NUT3W Numbering software for BSch3V
    Copyright (C) 2004-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

#pragma once
#ifdef _MSVC
	#pragma warning (disable: 4786)
#endif

#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <string>
#include <algorithm>
#include <list>
using namespace std;
#include "xbschstringlist.h"
#include "ce3io.h"
#include "coord.h"
//#include "xbschobj.h"
//#include "xbschjunc.h"
//#include "xbschlabel.h"
//#include "xbschcomment.h"
//#include "xbschtag.h"
//#include "xbschcomponent.h"
//
//#include "xbschline.h"
////#include "xbschwirenl.h"
//#include "xbschentry.h"
//#include "xbschdelobj.h"
//#include "xbschsheetinfo.h"
//#include "xbschdoc.h"

#define MAX_SCH_FILES 64 


class PListParam{

public:
enum PL_FILETYPE
{
	PL_FILETYPE_CSV =0,
	PL_FILETYPE_XML =2
};

public:
	int listtype;
	//bool plAvoidZeroSuppressingOnMsExcel;
	bool plFlagMfr;
	bool plFlagMfrPn;
	bool plFlagPackage;
	bool plFlagNote;
	bool plFlagInfo;
	PListParam(){
		listtype = 0;	//PL3Wł 0,1: CSV,  2:SYLK
		//plAvoidZeroSuppressingOnMsExcel = false;
		plFlagMfr = false;
		plFlagMfrPn = false;
		plFlagPackage = false;
		plFlagNote = false;
		plFlagInfo = false;
	}
};

//class SNutDataElement
//{
//public:
//	wstring record;
//	bool	newline;
//	SNutDataElement(){newline = false;}
//	~SNutDataElement(){}
//};


//typedef list<SNutDataElement*> SNutDataElementList;
//typedef list<SNutDataElement*>::iterator SNutDataElementListIterator;


// SNutDataFile
// CE3t@CƂ̊ǗNX
class SNutDataFile
{
public:
	wstring m_filename;

	SNutDataFile(){}
	~SNutDataFile();
};

class SNutComponent
{
public:
	//t@Cԍ
	int m_index;

	//i̍W
	SPoint m_p;

	//CǔĂяo
	wstring m_orgname;

	//i
	wstring m_name;
	
	//t@Xԍ
	//SNutDataElement* m_refNumElement;	//SNutDataElement̎̂Ǘ̂ SNutDataFileNXȂ̂ deleteȂ
	wstring m_prefix;
	int m_suffix;
	bool m_validSuffix;

	wstring m_mfr;
	wstring m_mfrpn;
	wstring m_package;
	wstring m_note;
	wstring m_componentNote;




	
	//ubNԍ
	//SNutDataElement* m_blockElement;	//SNutDataElement̎̂Ǘ̂ SNutDataFileNXȂ̂ deleteȂ
	//int m_block;
	//int m_blocks;
	//bool m_powComp;
	//bool m_ignore;
	//bool m_keep;	//XVȂꍇtrueɂB
	//bool m_checked;
	//bool m_setPowComp;


	void SetRef(/*SNutDataElement* pElement,*/const TCHAR* pcszRefnum);
	//void SetBlock(SNutDataElement* pElement,const TCHAR* block);
	//void update(); //QƔԍƃubNԍSNutDataElement̎̂ɔf
	SNutComponent()
	{
		//m_refNumElement = NULL;
		m_suffix = 0;
		m_validSuffix = false;	
		//m_blockElement = NULL;
		//m_block = 0;
		//m_blocks = 1;
		//m_powComp = false;
		//m_ignore = false;
		//m_keep= false;
		//m_checked = false;
		//m_setPowComp = false;
	}

};


typedef list<SNutComponent*> NutCompList;
typedef list<SNutComponent*>::iterator NutCompListIterator;
typedef SNutComponent* PSNutComponent;

class SPlist
{
	int m_dataFileCount;
	SNutDataFile m_schFiles[MAX_SCH_FILES];
	
	//wstring* m_prefixFilterArray;
	//int m_prefixFilterCount;

	NutCompList m_complist;

	PSNutComponent* m_compArray;
	int m_compArrayCount;

	//PSNutComponent* m_powcompArray;
	//int m_powcompArrayCount;
	void pickupComponent();
	void clearCompArray();
	void clearSchFiles();
	//void sortPOS();
	//void sortREF();
	//void createBackup();
	//bool DoPrefixFilter(const char* pcszPrefix);

public:
	//bool m_enablePrefixFilter;
	//bool m_prefixFilterDontMode;
	//bool m_newlyOnly;

	//string m_prefixFilterString;


public:
	SPlist();
	~SPlist();
	int fileCount(){return m_dataFileCount;}
	int readFile(const TCHAR* path);	//ǂݍ݂ɐ0Ԃ


	PListParam m_param;

	void convertToCsvRecord(const wstring& src,wstring& dest);
	void encodeXMLstring(const wstring& src,wstring& dest);
	int writePartsList(const TCHAR* filename);


	//CSV`̕iXgo
	int writePartsList_csv(const TCHAR* filename);


	//XML`̕iXgo
	int writePartsList_xml(const TCHAR* filename);


	static const TCHAR* xmlHeader;

enum COLUMN_WIDTH
{
	COLUMN_WIDTH_STATUS = 40,
	COLUMN_WIDTH_PREFIX = 50,
	COLUMN_WIDTH_SUFFIX = 50,
	COLUMN_WIDTH_NAME = 120,
	COLUMN_WIDTH_MFR = 80,
	COLUMN_WIDTH_MFRPN = 120,
	COLUMN_WIDTH_PKG = 80,
	COLUMN_WIDTH_NOTE = 200,
	COLUMN_WIDTH_COMP_NOTE = 200
};


	//int renameToBackup();
	//void restore();
	//int saveFiles();
	//int anumNewlyOnly(int init,int step);
	//int anum(int init,int step,bool newonly);
	//int renum(int init,int step);
	//const TCHAR* filename(int n);

	//void setPrefixFilter(const TCHAR* filterPrefixes);

};
